% Copyright INRIA
% Definition a all cells used to test M2SCI
% V.C.

% Generic test cell (used in most of tests)
emptymatcell={'[]',...
	      'Unknown_Type([])',...
	      'Unknown_Dims([])'};

intmatcell={'[1]',...
	    '[1,2,3]',...
	    '[1;2;3]',...
	    '[1,2,3;4,5,6]',...
	    'Unknown_Type([1])',...
	    'Unknown_Type([1,2,3])',...
	    'Unknown_Type([1;2;3])',...
	    'Unknown_Type([1,2,3;4,5,6])',...
	    'Unknown_Dims([1])',...
	    'Unknown_Dims([1,2,3])',...
	    'Unknown_Dims([1;2;3])',...
	    'Unknown_Dims([1,2,3;4,5,6])'};

complexmatcell={'[i]',...
		'[i,2i,3i]',...
		'[i;2i;3i]',...
		'[i,2i,3i;4i,5i,6i]',...
		'Unknown_Type([i])',...
		'Unknown_Type([i,2i,3i])',...
		'Unknown_Type([i;2i;3i])',...
		'Unknown_Type([i,2i,3i;4i,5i,6i])',...
		'Unknown_Dims([i])',...
		'Unknown_Dims([i,2i,3i])',...
		'Unknown_Dims([i;2i;3i])',...
		'Unknown_Dims([i,2i,3i;4i,5i,6i])'};

stringmatcell={'[''s'']',...
	       '[''str1'']',...
	       '[''str1'',''str2'',''str3'']',...
	       '[''str1'';''str2'';''str3'']',...
	       '[''str1'',''str2'',''str3'';''str4'',''str5'',''str6'']',...
	       'Unknown_Type([''s''])',...
	       'Unknown_Type([''str1''])',...
	       'Unknown_Type([''str1'',''str2'',''str3''])',...
	       'Unknown_Type([''str1'';''str2'';''str3''])',...
	       'Unknown_Type([''str1'',''str2'',''str3'';''str4'',''str5'',''str6''])',...
	       'Unknown_Dims([''s''])',...
	       'Unknown_Dims([''str1''])',...
	       'Unknown_Dims([''str1'',''str2'',''str3''])',...
	       'Unknown_Dims([''str1'';''str2'';''str3''])',...
	       'Unknown_Dims([''str1'',''str2'',''str3'';''str4'',''str5'',''str6''])'};
	       
booleanmatcell={'[[1]==[1]]',...
		'[[1,2,3]==[1,0,3]]',...
		'[[1;2;3]==[1;0;3]]',...
		'[[1,2,3;4,5,6]==[1,0,3;4,5,0]]',...
		'Unknown_Type([[1]==[1]])',...
		'Unknown_Type([[1,2,3]==[1,0,3]])',...
		'Unknown_Type([[1;2;3]==[1;0;3]])',...
		'Unknown_Type([[1,2,3;4,5,6]==[1,0,3;4,5,0]])',...
		'Unknown_Dims([[1]==[1]])',...
		'Unknown_Dims([[1,2,3]==[1,0,3]])',...
		'Unknown_Dims([[1;2;3]==[1;0;3]])',...
		'Unknown_Dims([[1,2,3;4,5,6]==[1,0,3;4,5,0]])'};

testcell = [emptymatcell,intmatcell,complexmatcell,stringmatcell,booleanmatcell];

% Other generic test cell (used for comparison with testcell...)
intmatcell1={'[1]',...
	     '[3,2,1]',...
	     '[3;2;1]',...
	     '[6,5,4;3,2,1]',...
	     'Unknown_Type([1])',...
	     'Unknown_Type([3,2,1])',...
	     'Unknown_Type([3;2;1])',...
	     'Unknown_Type([6,5,4;3,2,1])',...
	     'Unknown_Dims([1])',...
	     'Unknown_Dims([3,2,1])',...
	     'Unknown_Dims([3;2;1])',...
	     'Unknown_Dims([6,5,4;3,2,1])'};

complexmatcell1={'[i]',...
		 '[3i,2i,i]',...
		 '[3i;2i;i]',...
		 '[6i,5i,4i;3i,2i,i]',...
		 'Unknown_Type([i])',...
		 'Unknown_Type([3i,2i,i])',...
		 'Unknown_Type([3i;2i;i])',...
		 'Unknown_Type([6i,5i,4i;3i,2i,i])',...
		 'Unknown_Dims([i])',...
		 'Unknown_Dims([3i,2i,i])',...
		 'Unknown_Dims([3i;2i;i])',...
		 'Unknown_Dims([6i,5i,4i;3i,2i,i])'};

stringmatcell1={'[''s'']',...
		'[''str1'']',...
		'[''str3'',''str2'',''str1'']',...
		'[''str3'';''str2'';''str1'']',...
		'[''str6'',''str5'',''str4'';''str3'',''str2'',''str1'']',...
		'Unknown_Type([''s''])',...
		'Unknown_Type([''str1''])',...
		'Unknown_Type([''str3'',''str2'',''str1''])',...
		'Unknown_Type([''str3'';''str2'';''str1''])',...
		'Unknown_Type([''str6'',''str5'',''str4'';''str3'',''str2'',''str1''])',...
		'Unknown_Dims([''s''])',...
		'Unknown_Dims([''str1''])',...
		'Unknown_Dims([''str3'',''str2'',''str1''])',...
		'Unknown_Dims([''str3'';''str2'';''str1''])',...
		'Unknown_Dims([''str6'',''str5'',''str4'';''str3'',''str2'',''str1''])'};
		
booleanmatcell1={'[[1]==[1]]',...
		 '[[1,2,3]==[1,2,0]]',...
		 '[[1;2;3]==[1;2;0]]',...
		 '[[1,2,3;4,5,6]==[1,2,0;4,0,6]]',...
		 'Unknown_Type([[1]==[1]])',...
		 'Unknown_Type([[1,2,3]==[1,2,0]])',...
		 'Unknown_Type([[1;2;3]==[1;2;0]])',...
		 'Unknown_Type([[1,2,3;4,5,6]==[1,2,0;4,0,6]])',...
		 'Unknown_Dims([[1]==[1]])',...
		 'Unknown_Dims([[1,2,3]==[1,2,0]])',...
		 'Unknown_Dims([[1;2;3]==[1;2;0]])',...
		 'Unknown_Dims([[1,2,3;4,5,6]==[1,2,0;4,0,6]])'};

testcell1 = [emptymatcell,intmatcell1,complexmatcell1,stringmatcell1,booleanmatcell1];

% Generic test cell containing only column vectors
% (used when Matlab require a vector as value)
intvectcell={'[1]',...
	     '[1,2,3]',...
	     '[1;2;3]',...
	     'Unknown_Type([1])',...
	     'Unknown_Type([1,2,3])',...
	     'Unknown_Type([1;2;3])',...
	     'Unknown_Dims([1])',...
	     'Unknown_Dims([1,2,3])',...
	     'Unknown_Dims([1;2;3])'};

complexvectcell={'[i]',...
		 '[i,2i,3i]',...
		 '[i;2i;3i]',...
		 'Unknown_Type([i])',...
		 'Unknown_Type([i,2i,3i])',...
		 'Unknown_Type([1+1i;2+2i;3+3i])',...
		 'Unknown_Dims([i])',...
		 'Unknown_Dims([i,2i,3i])',...
		 'Unknown_Dims([i;2i;3i])'};

stringvectcell={'[''str1'']',...
		'[''str1'',''str2'',''str3'']',...
		'[''str1'',''str2'',''str3'']''',...
		'Unknown_Type([''str1''])',...
		'Unknown_Type([''str1'',''str2'',''str3''])',...
		'Unknown_Type([''str1'',''str2'',''str3'']'')',...
		'Unknown_Dims([''str1''])',...
		'Unknown_Dims([''str1'',''str2'',''str3''])',...
		'Unknown_Dims([''str1'',''str2'',''str3'']'')'};

booleanvectcell={'[[1]==[1]]',...
		 '[[1,2,3]==[1,0,3]]',...
		 '[[1;2;3]==[1;0;3]]',...
		 'Unknown_Type([[1]==[1]])',...
		 'Unknown_Type([[1,2,3]==[1,0,3]])',...
		 'Unknown_Type([[1;2;3]==[1;0;3]])',...
		 'Unknown_Dims([[1]==[1]])',...
		 'Unknown_Dims([[1,2,3]==[1,0,3]])',...
		 'Unknown_Dims([[1;2;3]==[1;0;3]])'};

testcellvect=[emptymatcell,intvectcell,complexvectcell,stringvectcell,booleanvectcell];		

% Generic test cell containing only square matrices
% Used when a square matrix is required by Matlab
intsqmatcell={'[1]',...
	      '[1,2,3;4,5,6;7,8,0]',...
	      'Unknown_Type([1])',...
	      'Unknown_Type([1,2,3;4,5,6;7,8,0])',...
	      'Unknown_Dims([1])',...
	      'Unknown_Dims([1,2,3;4,5,6;7,8,0])'};

complexsqmatcell={'[i]',...
		  '[i,2i,3i;4i,5i,6i;7i,8i,0]',...
		  'Unknown_Type([i])',...
		  'Unknown_Type([i,2i,3i;4i,5i,6i;7i,8i,0])',...
		  'Unknown_Dims([i])',...
		  'Unknown_Dims([i,2i,3i;4i,5i,6i;7i,8i,0])'};
		  
stringsqmatcell={'[''a'']',...
		 '[''a'',''0'',''0'';''d'',''0'',''f'';''g'',''h'',''0'']',...
		 'Unknown_Type([''a''])',...
		 'Unknown_Dims([''a'',''0'',''0'';''d'',''0'',''f'';''g'',''h'',''0''])',...
		 'Unknown_Dims([''a''])',...
		 'Unknown_Dims([''a'',''0'',''0'';''d'',''0'',''f'';''g'',''h'',''0''])'};

booleansqmatcell={'[[1]==[1]]',...
		  '[[1,2,3;4,5,6;7,8,9]==[1,0,3;4,5,0;0,8,9]]',...
		  'Unknown_Type([[1]==[1]])',...
		  'Unknown_Type([[1,2,3;4,5,6;7,8,9]==[1,0,3;4,5,0;0,8,9]])',...
		  'Unknown_Dims([[1]==[1]])',...
		  'Unknown_Dims([[1,2,3;4,5,6;7,8,9]==[1,0,3;4,5,0;0,8,9]])'};

testcellsq=[emptymatcell,intsqmatcell,complexsqmatcell,stringsqmatcell,booleansqmatcell];

% Generic test cell containing (used for functions such as ceil...)
floatmatcell={'[1.1]',...
	      '[1.1,2.2,3.3]',...
	      '[1.1;2.2;3.3]',...
	      '[1.1,2.2,3.3;4.4,5.5,6.6]',...
	      '[1.1+1.1i]',...
	      '[1.1+1.1i,2.2+2.2i,3.3+3.3i]',...
	      '[1.1+1.1i;2.2+2.2i;3.3+3.3i]',...
	      '[1.1+1.1i,2.2+2.2i,3.3+3.3i;4.4+4.4i,5.5+5.5i,6.6+6.6i]',...
	      'Unknown_Type([1.1])',...
	      'Unknown_Type([1.1,2.2,3.3])',...
	      'Unknown_Type([1.1;2.2;3.3])',...
	      'Unknown_Type([1.1,2.2,3.3;4.4,5.5,6.6])',...
	      'Unknown_Type([1.1+1.1i])',...
	      'Unknown_Type([1.1+1.1i,2.2+2.2i,3.3+3.3i])',...
	      'Unknown_Type([1.1+1.1i;2.2+2.2i;3.3+3.3i])',...
	      'Unknown_Type([1.1+1.1i,2.2+2.2i,3.3+3.3i;4.4+4.4i,5.5+5.5i,6.6+6.6i])',...
	      'Unknown_Dims([1.1])',...
	      'Unknown_Dims([1.1,2.2,3.3])',...
	      'Unknown_Dims([1.1;2.2;3.3])',...
	      'Unknown_Dims([1.1,2.2,3.3;4.4,5.5,6.6])',...
	      'Unknown_Dims([1.1+1.1i])',...
	      'Unknown_Dims([1.1+1.1i,2.2+2.2i,3.3+3.3i])',...
	      'Unknown_Dims([1.1+1.1i;2.2+2.2i;3.3+3.3i])',...
	      'Unknown_Dims([1.1+1.1i,2.2+2.2i,3.3+3.3i;4.4+4.4i,5.5+5.5i,6.6+6.6i])'};

testcellfloat =[emptymatcell,intmatcell,complexmatcell,stringmatcell,booleanmatcell,floatmatcell]; 

