% Copyright INRIA
% Batch file which generate test files for M2SCI
% V.C.

definetestcells;
global TESTS_SUITE_DIR;
TESTS_SUITE_DIR='../../generated_files/';

disp('Generating functions test files...');

testcellnoboolean=[emptymatcell,intmatcell,complexmatcell,stringmatcell];
testcellnoboolean1=[emptymatcell,intmatcell1,complexmatcell1,stringmatcell1];
testcellsqnoboolean=[emptymatcell,intsqmatcell,complexsqmatcell,stringsqmatcell];
testcellvectnoboolean=[emptymatcell,intvectcell,complexvectcell,stringvectcell];		
testcellfloatnoboolean=[emptymatcell,intmatcell,complexmatcell,stringmatcell,floatmatcell];

genoptestfile('+',{{'no',{testcell,testcell}},...
                     {'yes',{testcell,{'1','''a'''}}},...
                     {'yes',{{'[]','inf','nan','1'},{'[]','inf','nan','1'}}}});

genoptestfile('-',{{'no',{testcell,testcell}},...
                     {'yes',{testcell,{'1','''a'''}}},...
                     {'yes',{{'[]','inf','nan','1'},{'[]','inf','nan','1'}}}});

genoptestfile('''',{{'yes',{testcell,{''}}}})

genoptestfile('.''',{{'yes',{testcell,{''}}}})

genoptestfile({'*';''''},{{'no',{testcellnoboolean,testcellnoboolean1}},...
                    {'yes',{testcellnoboolean,{'1'}}},...
                    {'yes',{{'[]','inf','nan','1'},{'[]','inf','nan','1'}}}})

genoptestfile('.*',{{'no',{testcell,testcell}},...
		    {'yes',{{'[]','inf','nan','1'},{'[]','inf','nan','1'}}}})

genoptestfile('/',{{'no',{testcellnoboolean,testcellnoboolean1}},...
                     {'yes',{testcellnoboolean,{'1','''a'''}}},...
                     {'yes',{{'inf','nan','1'},{'inf','nan','1'}}}});

genoptestfile('./',{{'no',{testcellnoboolean,testcellnoboolean1}},...
		    {'yes',{testcellnoboolean,{'1','''a'''}}},...
		    {'yes',{{'[]','inf','nan','1'},{'[]','inf','nan','1'}}}})

genoptestfile('\',{{'no',{testcellnoboolean,testcellnoboolean1}},...
		   {'yes',{{'inf','nan','1'},{'inf','nan','1'}}}});

genoptestfile('.\',{{'no',{testcellnoboolean,testcellnoboolean1}},...
		    {'yes',{testcellnoboolean,{'1','''a'''}}},...
		    {'yes',{{'[]','inf','nan','1'},{'[]','inf','nan','1'}}}})

genoptestfile('^',{{'yes',{testcellsq,{'''a''','1','2','-1','-2','inf','nan'}}},...
                   {'yes',{{'1','2','inf','nan'},testcellsq}},...
		   {'yes',{{'''a''','1','2','-1','-2','inf','nan'},{'''a''','1','2','-1','-2','inf','nan'}}}})
		   
genoptestfile('.^',{{'yes',{testcellsq,{'''a''','1','2','-1','-2','inf','nan'}}},...
		    {'yes',{{'1','''a''','2','inf','nan'},testcellsq}},...
		    {'yes',{{'''a''','1','2','-1','-2','inf','nan'},{'''a''','1','2','-1','-2','inf','nan'}}}});

tmptestcell1 = [emptymatcell,intmatcell,stringmatcell,booleanmatcell];
tmptestcell2 = [emptymatcell,intmatcell1,stringmatcell1,booleanmatcell1];
tmptestcell={'[1==1]','Unknown_Dims([1==1])','Unknown_Type([1==1])',...
	     '1','Unknown_Dims(1)','Unknown_Type(1)',...
	     '''a''','Unknown_Dims(''a'')','Unknown_Type(''a'')'};
genoptestfile('&',{{'no',{tmptestcell1,tmptestcell2}},...
		   {'yes',{tmptestcell,tmptestcell1}},...
		   {'yes',{tmptestcell1,tmptestcell}}});

genoptestfile('|',{{'no',{tmptestcell1,tmptestcell2}},...
		   {'yes',{tmptestcell,tmptestcell1}},...
		   {'yes',{tmptestcell1,tmptestcell}}});

genoptestfile('~',{{'yes',{{''},tmptestcell1}}});

tmptestcell={'[]','nan','Unknown_Dims(1)','10','100'};
genoptestfile(':',{{'no',{{'1','''a''','-1'},{'100','''j''','-100'}}},...
		   {'no',{{'1','''f''','-1'},{'1','-1','-10'},{'100','''b''','-100'}}},...
		   {'no',{tmptestcell,tmptestcell}},...
		   {'no',{tmptestcell,tmptestcell,tmptestcell}}});

genoptestfile('==',{{'no',{testcell,testcell1}},{'yes',{testcell,{'1','-1','''a'''}}}});
genoptestfile('<',{{'no',{testcell,testcell1}},{'yes',{testcell,{'1','-1','''a'''}}}});
genoptestfile('>',{{'no',{testcell,testcell1}},{'yes',{testcell,{'1','-1','''a'''}}}});
genoptestfile('<=',{{'no',{testcell,testcell1}},{'yes',{testcell,{'1','-1','''a'''}}}});
genoptestfile('>=',{{'no',{testcell,testcell1}},{'yes',{testcell,{'1','-1','''a'''}}}});
genoptestfile('~=',{{'no',{testcell,testcell1}},{'yes',{testcell,{'1','-1','''a'''}}}});
 
% Special test to see if m2sci_syntax does a good work for digits
% followed by a dot operator
genoptestfile({'.^';'.*'},{{'no',{testcellnoboolean,testcellnoboolean,testcellnoboolean}}})
